package application;

	import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TextField;


	public class InserisciController {
		private Model model ;
		
		@FXML
	    private ResourceBundle resources;

	    @FXML
	    private URL location;

	    @FXML
	    private CheckBox box_accettata;

	    @FXML
	    private CheckBox box_non_legata;


	    @FXML
	    private CheckBox box_precedente;

	    @FXML
	    private Button btn_inserisci;

	    @FXML
	    private TextField txt_num_inserite;

	    @FXML
	    private TextField txt_parola;


	    @FXML
	    void inserisciAction(ActionEvent event) {
	    	String parola = txt_parola.getText();
	    	
	    	resetBox();
	    	
	    	int res = model.check(parola);
	    	
	    	switch(res){
	    	case 1: box_precedente.setSelected(true);
	    		break;
	    	case 2: box_non_legata.setSelected(true);
    			break;
    	    default:
    	    	box_accettata.setSelected(true);
    	    	txt_num_inserite.setText(model.getNum()+"");
	    	}
	    	
	    	return;
	    }

	    private void resetBox(){
	    	box_accettata.setSelected(false);
	    	box_non_legata.setSelected(false);
	    	box_precedente.setSelected(false);
	    	
	    }
	    
	    @FXML
	    void initialize() {
	        assert box_accettata != null : "fx:id=\"box_accettata\" was not injected: check your FXML file 'es4.fxml'.";
	        assert box_non_legata != null : "fx:id=\"box_non_legata\" was not injected: check your FXML file 'es4.fxml'.";
	        assert box_precedente != null : "fx:id=\"box_precedente\" was not injected: check your FXML file 'es4.fxml'.";
	        assert btn_inserisci != null : "fx:id=\"btn_inserisci\" was not injected: check your FXML file 'es4.fxml'.";
	        assert txt_num_inserite != null : "fx:id=\"txt_num_inserite\" was not injected: check your FXML file 'es4.fxml'.";
	        assert txt_parola != null : "fx:id=\"txt_parola\" was not injected: check your FXML file 'es4.fxml'.";


	    }


	    public Model getModel() {
			return model;
		}

		public void setModel(Model model) {
			this.model = model;
		}

	}
