/**
 * Sample Skeleton for "Impicc.fxml" Controller Class
 * You can copy and paste this code into your favorite IDE
 **/

package application;

import java.net.URL;
import java.util.ResourceBundle;

import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Label;
import javafx.scene.control.ProgressBar;
import javafx.scene.control.TextField;


public class ImpiccController {
	
	private Model model ;

    @FXML // ResourceBundle that was given to the FXMLLoader
    private ResourceBundle resources;

    @FXML // URL location of the FXML file that was given to the FXMLLoader
    private URL location;

    @FXML // fx:id="errorBar"
    private ProgressBar errorBar; // Value injected by FXMLLoader

    @FXML // fx:id="errorNum"
    private TextField errorNum; // Value injected by FXMLLoader

    @FXML // fx:id="lettera"
    private ChoiceBox<String> lettera; // Value injected by FXMLLoader

    @FXML // fx:id="parolaOut"
    private TextField parolaOut; // Value injected by FXMLLoader
    
    @FXML // fx:id="lblMorto"
    private Label lblMorto; // Value injected by FXMLLoader

    @FXML // fx:id="lblVinto"
    private Label lblVinto; // Value injected by FXMLLoader
    
    @FXML
    private Button btn_nuova;
    

    @FXML
    private TextField parolaIn;


    @FXML
    private TextField txt_solution;


    @FXML
    void newAction(ActionEvent event) {
    	if(parolaIn.getText().isEmpty()){
    	parolaOut.setText("inserisci una parola");	
    	}
    	else {model.newMatch(parolaIn.getText());
    	updateView();
    	}
    	 
    	
    }
    
    public class LetterChangeListener implements ChangeListener<Number>{
    	
    	ObservableList<String> theList  ;
    	
    	public LetterChangeListener(ObservableList<String> theList) {
    		this.theList = theList ;
    	}

    	@Override
    	public void changed(ObservableValue<? extends Number> observable,
    			Number oldValue, Number newValue) {
    		// TODO Auto-generated method stub
    		
    		String letter = theList.get(newValue.intValue()) ;
    		
    		model.tryLetter(letter) ;
    		updateView() ;
    	}


    }

    

    @FXML // This method is called by the FXMLLoader when initialization is complete
    void initialize() {
        assert errorBar != null : "fx:id=\"errorBar\" was not injected: check your FXML file 'Impicc.fxml'.";
        assert errorNum != null : "fx:id=\"errorNum\" was not injected: check your FXML file 'Impicc.fxml'.";
        assert lettera != null : "fx:id=\"lettera\" was not injected: check your FXML file 'Impicc.fxml'.";
        assert parolaOut != null : "fx:id=\"parolaOut\" was not injected: check your FXML file 'Impicc.fxml'.";
        assert txt_solution != null : "fx:id=\"txt_solution\" was not injected: check your FXML file 'Impicc.fxml'.";
        assert parolaIn != null : "fx:id=\"parolaIn\" was not injected: check your FXML file 'Impicc.fxml'.";
        // Initialize your logic here: all @FXML variables will have been injected
        
        /* Set up choicebox contents */
        for( char ch='a'; ch<='z'; ch++ )
        	lettera.getItems().add(String.valueOf(ch)) ;
        
        lettera.getSelectionModel().selectedIndexProperty().addListener(new LetterChangeListener(lettera.getItems())) ;

    }
    
    public void updateView() {
		errorNum.setText(String.valueOf(model.getnErrori())) ;
		errorBar.setProgress(model.getErrorProgress()) ;
		parolaOut.setText(model.getRisultato()) ;
		
		lblMorto.setVisible(model.isDead()) ;
		lblVinto.setVisible(model.isWinner()) ;

		if(model.isDead()){
			txt_solution.setText(model.getSegreto());
		}
    }


	public Model getModel() {
		return model;
	}


	public void setModel(Model model) {
		this.model = model;
		
	}

}
