package application;

import java.util.ArrayList;
import java.util.List;

public class Model {
	
	private String segreto ;
	
	private StringBuffer risultato ;
	
	private int nErrori ;
	
	private int nTentativi ;
	
	private int nUnderscore ;
	
	private List<String> lettereProvate ;
	
	private final int nErroriMax = 10 ;
	
	
	
	// Model methods

	
	public void newMatch(String segreto) {
		
		setSegreto(segreto) ;
		nErrori = nTentativi = 0 ;
		nUnderscore = segreto.length() ;
		lettereProvate = new ArrayList<String>() ;
		
		StringBuffer s = new StringBuffer(segreto.length()) ;
		for(int i=0; i<segreto.length(); i++)
			s.append("_") ;
		
		risultato = s ;
	}
	
	

	public boolean tryLetter(String letter) {
		nTentativi++ ;
		if(lettereProvate.contains(letter)) {
			// errore: ha ri-tentato una lettera gi? provata
			nErrori++ ;
			return false ;
		}
		
		lettereProvate.add(letter) ;
		
		boolean trovato = false ;
		for(int i=0; i<segreto.length(); i++) {
			if(segreto.regionMatches(i, letter, 0, 1)) {
				trovato = true ;
				risultato.setCharAt(i, letter.charAt(0)) ;
				nUnderscore-- ;
				//System.out.println("Underscore "+nUnderscore) ;
			}
		}
		
		if (trovato) {
			return true ;
		} else {
			nErrori++ ;
			return false ;
		}
	}
	
	
	public boolean isWinner() {
		return nUnderscore==0 ;
	}
	
	public boolean isDead() {
		return nErrori>=nErroriMax ;
	}
	
	public double getErrorProgress() {
		return (double)nErrori / (double)nErroriMax ;
	}
	
	// Standard getters and setters

	public String getSegreto() {
		return segreto;
	}

	public void setSegreto(String segreto) {
		this.segreto = segreto;
	}

	public String getRisultato() {
		return risultato.toString();
	}

	public int getnErrori() {
		return nErrori;
	}

	public void setnErrori(int nErrori) {
		this.nErrori = nErrori;
	}

	public int getnTentativi() {
		return nTentativi;
	}

	public void setnTentativi(int nTentativi) {
		this.nTentativi = nTentativi;
	}

	public List<String> getLettereProvate() {
		return lettereProvate;
	}
}
